package org.apache.geronimo.samples.document.web;

import java.io.IOException;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.geronimo.samples.document.ejb.DocumentManager;
import org.apache.geronimo.samples.document.ejb.DocumentManagerHome;

public class UploadServlet extends HttpServlet{

	private static final long serialVersionUID = -2773446199481416101L;
	private DocumentManagerHome docManagerHome;
	
	
	public void destroy() {
		docManagerHome = null;
		super.destroy();
	}

	public void init() throws ServletException {
		try {
			Context context = new InitialContext();
			docManagerHome = (DocumentManagerHome)context.lookup(DocumentManagerHome.JNDI_NAME);
		} catch (Throwable e) {
			throw new ServletException(e);
		}
	}

	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		DocumentManager docManager = upload();
		req.setAttribute("result", docManager.upload());
		req.getRequestDispatcher("jsp/main.jsp").forward(req, res);
	}

	protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		doGet(req, res);
	}
	
	
	private DocumentManager upload() throws ServletException, IOException {
		try {
			return docManagerHome.create();
		} catch (CreateException e) {
			throw new ServletException(e);
		} 
	}

}
